﻿using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.SbEnSk;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class HappyFlowScenario : SbEnSkScenarioBase
{
    public override string Name => "Happy flow scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Kennisgeving");

        //Happy flow with end state schuldregeling geaccordeerd
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord),
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Saldoverzoek");

        // Happy flow with end state schuldregeling geaccordeerd
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));
    }
}